<template>
  <div class="question-container flex column align-start">
    <div class="text m-t-10 m-b-10">
      {{ question.seq }}.&nbsp;&nbsp; {{ question.text }}
    </div>
    <div class="flex column align-start content-end" v-if="question.seq === 10">
      <img src="@/assets/1977GDP.png" alt="" width="800px" />
      <img src="@/assets/1987GDP.png" alt="" width="800px" />
      <img src="@/assets/1997GDP.png" alt="" width="800px" />
      <img src="@/assets/2007GDP.png" alt="" width="800px" />
      <img src="@/assets/2017GDP.png" alt="" width="800px" />
    </div>
    <div class="choices-container flex row m-t-10 m-b-10">
      <el-radio-group
        v-if="question.type === questionTypes[0]"
        v-model="choice"
        @change="changeHandler"
        size="small"
        class="flex auto column align-start content-end"
      >
        <el-radio
          style="margin-left:0"
          class="m-b-20"
          v-for="(choice, index) in question.choices"
          :key="index"
          :label="choice.id"
          border
          >{{ choice.label }}. {{ choice.text }}</el-radio
        >
      </el-radio-group>
      <el-checkbox-group
        v-model="choices"
        v-if="question.type === questionTypes[1]"
        @change="changeHandler"
        size="small"
        class="flex auto column align-start content-end"
      >
        <el-checkbox
          style="margin-left:0"
          class="m-b-20"
          v-for="(choice, index) in question.choices"
          :key="index"
          :label="choice.id"
          border
          >{{ choice.label }}. {{ choice.text }}</el-checkbox
        >
      </el-checkbox-group>
      <el-input
        v-if="question.type === questionTypes[2]"
        class="textarea-style"
        type="textarea"
        v-model="text"
        :rows="4"
        @blur="changeHandler"
      ></el-input>
    </div>
  </div>
</template>

<script>
export default {
  name: "QuestionItem",
  props: {
    question: {
      type: Object,
      required: true
    }
  },
  data() {
    return {
      questionTypes: ["Radio", "Multiple Selection", "Open Question"],
      choice: null,
      choices: [],
      text: ""
    };
  },
  methods: {
    changeHandler() {
      switch (this.question.type) {
        case this.questionTypes[0]:
          return this.$emit("change", {
            id: this.question.id,
            type: this.questionTypes[0],
            data: [this.choice]
          });
        case this.questionTypes[1]:
          return this.$emit("change", {
            id: this.question.id,
            type: this.questionTypes[1],
            data: this.choices
          });
        case this.questionTypes[2]:
          return this.$emit("change", {
            id: this.question.id,
            type: this.questionTypes[2],
            data: this.text
          });
      }
    }
  }
};
</script>

<style lang="scss" scoped>
@import "@/styles/theme.scss";
.question-container {
  text-align: left;
  margin: 10px 0px;
}
.choices-container {
  width: 100%;
}
.textarea-style {
  flex: 1;
}
.text {
  color: $font-main-color;
  font-size: $font-min-title-size;
  line-height: 1.5;
}
</style>
